#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mstruct.h"

#define MAXREAD 100
#define MINREAD 10

//  when I am ambitious I should write code to find USER.BBS file instead of
//  requiring it to be in same directory program is run from

char tempbuf[128];
int priv_level = -1;
char plevels[] = "DLNWPFECA-SHT";
struct _usr user;

void Error(char *errtext)
{
//  when I am ambitious i should report more information about the error

    fprintf(stderr,"\nFile I/O Error!");
    fprintf(stderr,errtext);
    return;
}

void processuser(struct _usr *pUsr, int numtoprocess)
{
	char userpriv;
	int i;

	for (i=0;i<numtoprocess;i++, pUsr++) {
	    if ((priv_level != -1) && (pUsr->priv != priv_level))
		continue;
	    if (pUsr->priv == -2)
		userpriv = 'T';
	    else if (pUsr->priv > strlen(plevels)-2)
		userpriv = ' ';
	    else
		userpriv = plevels[pUsr->priv];
	    fprintf(stdout,"%c %-20.20s %-24.24s %-14.14s\n",userpriv, pUsr->name, pUsr->city, pUsr->phone);
	}
	return;
}

main(int argc, char **argv)
{
    struct _usr *pUser;
    char priv_char;
    char *which_priv;
    FILE *userfile;
    size_t itemsread;
    int x = 0, s_len, n_to_read = MAXREAD;

    if (argc > 1) {
	priv_char = toupper(argv[1][0]);
	which_priv = strchr(plevels,priv_char);
	if (which_priv == NULL)
	    priv_level = -1;
	else
	    priv_level = (which_priv - plevels) / sizeof(char);
	if (priv_level == strlen(plevels) -1)
	    priv_level = -2; // TWIT special case
    }
    else
	priv_level = -1;

    if ((userfile=fopen("USER.BBS","r+b")) == NULL) {
	Error("\n\tError opening USER.BBS\n");
	exit(1);
    }
    fread(&user,sizeof(struct _usr),1,userfile);
    s_len = user.struct_len ? user.struct_len*20 : 180;
    pUser = malloc(MAXREAD*s_len);
    if (pUser == NULL) {
	n_to_read = MINREAD;
	pUser = malloc(MINREAD*s_len);
	if (pUser == NULL) {
	    n_to_read = 1;
	    pUser = &user;
	}
    }
    fprintf(stderr,"\nStart of output.\n");
    do {
	fseek(userfile,(long)x*(long)s_len * n_to_read,SEEK_SET);
	itemsread = fread(pUser,sizeof(struct _usr),n_to_read,userfile);
	if (itemsread < n_to_read) {
	    if (ferror(userfile)) {
		sprintf(tempbuf,"\n\tError reading USER.BBS (%d)\n",(itemsread+1) + x*n_to_read);
		Error(tempbuf);
		break;
	    }
	}
	if (feof(userfile)) {
	    if (itemsread)
		processuser(pUser, itemsread);
	    fprintf(stderr,"End of output.\n");
	    break;
	}
	processuser(pUser, itemsread);
	x++;
    } while (itemsread > 0);
    fclose(userfile);
    return(0);
}
